unit DATASEG; {Unit 11 of NEWIDEOLOG.PAS}

interface

  uses
    GLOBALS, UTILS, MATHS, POST, SCREEN, LEGENDS, PERIGRAM, POLYNOME, Crt, Graph;

  procedure PlotTheData (var dataBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var dataVector: longVector);

   procedure SegmentedPlot (var SCREENBOX, POSTBOX: IBOX;
                  var dataBOX: rBOX;
                  var dataVector: longVector;
                  var legend: string);

  procedure LogOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure SumOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure AlternatingVectorSum (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure DiffOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure SecondDiffOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure SecondDiffandCentralise (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure CentralisedDiffernces (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure SecondDiffsCentralised (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure DoubleDifference (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure SeasonalDifference (seasonLength: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure Decimate (step: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure SubsampleTheData (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure DiscardData (var SCREENBOX: IBOX;
                  var dataBOX: rBOX;
                  var dateVector: longVector);

  procedure ShortenTheData (var discard: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure SegmentTheData (var SCREENBOX, POSTBOX: IBOX;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure DiscardQuestion (var discard: Boolean);

  procedure DiscardExtraData (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure TransferTheData (var diffOrder: integer;
                  var dataBOX, trendBOX: rBOX;
                  var dataVector, trendVector: longVector);

  procedure ExplainWeightedRegression;

  procedure FitPolyTrend (var polyParas: polyParameters;
                  var dataBOX, trendBOX, residueBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var dataVector, trendVector, residueVec: longVector);

  procedure MakeFrequencyBand (var dataBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var stripRect: integerRect;
                  var postRect: realRect);

  procedure FillPostRect (var F: text;
                  var PostRect: realRect);

  procedure PlotThePeriodogam (var dataBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var dataVector: longVector;
                  var legend: string);

  procedure MultiPeriodogram (superimpose: boolean;
                   var SCREENBOX: IBOX;
                   var dataBOX: rBOX;
                   var dataVector: longVector);

  procedure ExitRoutine (var dataBOX, trendBOX, residueBOX, seasonBOX: rBOX;
                  var dataVector, trendVector, residueVec, seasonVec: longVector);
{It seems that this is not used: <SaveAndExit takes> its place}

  procedure GenerateTestData (var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure EndYearInterpolation (var alpha, beta: real;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure RotateData (RoteNo: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  procedure AntiRotateData (RoteNo: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  {Data Cumulation should be here}

implementation

  {_________________________________________________}

  procedure PlotTheData (var dataBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var dataVector: longVector);
    var
      legend: string;

  begin
    if (thereIsData = false) then
      begin
        SysBeep(3);
        ReadTheData(dataBOX, dataVector);
      end;

    if noPageParameters then
      begin
        SysBeep(3);
        PageSetUp(SCREENBOX, POSTBOX, PSPict, TeXFormat);
      end;

    legend := DataLegend(dataBOX, dataName);
    ScreenMakePlot(dataBOX, SCREENBOX, dataVector, legend);

    if (PSPict = true) then
      WritePostFile(dataBOX, POSTBOX, dataVector, legend);

  end; {PlotTheData}

{________________________________________________}

  procedure SegmentedPlot (var SCREENBOX, POSTBOX: IBOX;
                  var dataBOX: rBOX;
                  var dataVector: longVector;
                  var legend: string);
    var
      plotNumber, s, t: integer;
      plotVector: longVector;
      plotBOX: rBOX;
      postFiles: boolean;

  begin
    plotNumber := 0;
    s := 0;
    plotBOX.NOPUNCT := dataBOX.segLength;
    repeat
      for t := 0 to plotBOX.NOPUNCT - 1 do
        plotVector[t] := dataVector[s + t];
      MakeDataBox(plotBOX, plotVector);

      GetGraphics(graphicsOn, SCREENBOX, currentMode);

      ScreenFrame(plotBOX, SCREENBOX);
      ScreenPlot(plotBOX, SCREENBOX, plotVector);
      {ScreenCaption(legend);}

    CallForReturn;
    Readln;
    CloseGraph;
    RestoreCrtMode;
    ClrScr;

      plotNumber := plotNumber + 1;
      s := s + dataBOX.segLength;
    until plotNumber = dataBOX.numbOfSegs;

    if (PSPict = true) then
      begin {PSPict = true}
        YesOrNo('    Do you wish to create the PostScript files', postFiles);
        if postFiles then
          begin {postFiles}
            plotNumber := 0;
            s := 0;
            plotBOX.NOPUNCT := dataBOX.segLength;

            repeat
              for t := 0 to plotBOX.NOPUNCT - 1 do
                plotVector[t] := dataVector[s + t];
              MakeDataBox(plotBOX, plotVector);

              WritePostFile(plotBOX, POSTBOX, plotVector, legend);

              plotNumber := plotNumber + 1;
              s := s + dataBOX.segLength;
            until plotNumber = dataBOX.numbOfSegs;

          end; {postFiles}
      end; {PSPict = true}

  end; {SegmentedPlot}

{________________________________________________}

  procedure LogOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);

    var
      i: integer;
      yMax, yMin, yMean: real;
      BadElements: boolean;
      logDataVec: longVector;

  begin
    i := 0;
    yMean := 0.0;
    badElements := false;
    logsTaken := true;
    while (i < dataBOX.NOPUNCT) and (BadElements = false) do
      begin {while}
        if dataVector[i] <= 0 then
          begin
            Writeln('     The data contains elements with values which are zero or negative.');
            Writeln;
            Writeln('     The operation of taking logarithms of the data must be aborted');
            badElements := true;
            logsTaken := false;
            Writeln(' ' : 64, '<RETURN>');
            Readln;
          end
        else
          begin
            logDataVec[i] := ln(dataVector[i]);
            if i = 0 then
              begin
                yMax := logDataVec[0];
                yMin := logDataVec[0];
              end;
            yMean := yMean + logDataVec[i];
            if logDataVec[i] > yMax then
              yMax := logDataVec[i];
            if logDataVec[i] < yMin then
              yMin := logDataVec[i];
            i := i + 1;
          end;
      end; {while}
    yMean := yMean / dataBOX.NOPUNCT;

    if badElements = false then
      begin
        logsTaken := true;
        dataVector := logDataVec;
        dataBOX.yMax := yMax; {the maximum value of y in the Data vector}
        dataBOX.yMin := yMin; {the minimum value of y in the Data vector}
        dataBOX.yMean := yMean;
      end;
  end; {LogOfVector}

  {_______________________________________________}

  procedure SumOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);
    var
      t: integer;

  begin
    dataBOX.yMax := dataVector[0];
    dataBOX.yMin := dataVector[0];
    dataBOX.yMean := dataVector[0];

    for t := 1 to dataBOX.NOPUNCT - 1 do
      begin {t}
        dataVector[t] := dataVector[t] + dataVector[t - 1];
        dataBOX.yMax := Rmax(dataBOX.yMax, dataVector[t]);
        dataBOX.yMin := Rmin(dataBOX.yMin, dataVector[t]);
        dataBOX.yMean := dataBOX.yMean + dataVector[t];
      end; {t}

    dataBOX.yMean := dataBOX.yMean / dataBOX.NOPUNCT;

  end; {SumOfVector}

 {________________________________________________}

  procedure AlternatingVectorSum (var dataBOX: rBOX;
                  var dataVector: longVector);
    var
      t, sign: integer;

  begin
    dataBOX.yMax := dataVector[0];
    dataBOX.yMin := dataVector[0];
    dataBOX.yMean := dataVector[0];

    sign := -1;
    for t := 1 to dataBOX.NOPUNCT - 1 do
      begin {t}
        dataVector[t] := dataVector[t] + sign * dataVector[t - 1];
        dataBOX.yMax := Rmax(dataBOX.yMax, dataVector[t]);
        dataBOX.yMin := Rmin(dataBOX.yMin, dataVector[t]);
        dataBOX.yMean := dataBOX.yMean + dataVector[t];
        sign := -sign;
      end; {t}

    dataBOX.yMean := dataBOX.yMean / dataBOX.NOPUNCT;

  end; {AlternatingVectorSum}

 {________________________________________________}

  procedure DiffOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);

   {dataBOX.NOPUNCT is reduced by one}

    var
      t: integer;
      yMax, yMin, yMean: real;

  begin
    yMean := 0.0;
    yMax := dataVector[1] - dataVector[0];
    yMin := yMax;
    for t := 0 to dataBOX.NOPUNCT - 2 do
      begin
        dataVector[t] := dataVector[t + 1] - dataVector[t];
        yMax := Rmax(ymax, dataVector[t]);
        yMin := Rmin(ymin, dataVector[t]);
        yMean := yMean + dataVector[t];
      end;
    dataBOX.NOPUNCT := dataBOX.NOPUNCT - 1;
    yMean := yMean / dataBOX.NOPUNCT;
    dataBOX.yMean := yMean;
    dataBOX.yMax := yMax; {the maximum value of y in the Data vector}
    dataBOX.yMin := yMin; {the minimum value of y in the Data vector}
    dataBOX.xMin := 0.0;
    dataBOX.xMax := dataBOX.NOPUNCT - 1;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;
    dataBOX.diffOrder := dataBOX.diffOrder + 1;

  end; {DiffOfVector}

  {________________________________________________}

  procedure SecondDiffOfVector (var dataBOX: rBOX;
                  var dataVector: longVector);

  {dataBOX.NOPUNCT is reduced by two}

    var
      t: integer;

  begin
    dataBOX.yMean := 0.0;
    dataBOX.yMax := dataVector[2] - 2 * dataVector[1] + dataVector[0];
    dataBOX.yMin := dataBOX.yMax;

    for t := 0 to dataBOX.NOPUNCT - 3 do
      begin
        dataVector[t] := dataVector[t + 2] - 2 * dataVector[t + 1] + dataVector[t];
        dataBOX.yMax := Rmax(dataBOX.yMax, dataVector[t]);
        dataBOX.yMin := Rmin(dataBOX.yMax, dataVector[t]);
        dataBOX.yMean := dataBOX.yMean + dataVector[t];
      end;

    dataBOX.NOPUNCT := dataBOX.NOPUNCT - 2;
    dataBOX.yMean := dataBOX.yMean / dataBOX.NOPUNCT;
    dataBOX.xMin := 0.0;
    dataBOX.xMax := dataBOX.NOPUNCT - 1;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;
    dataBOX.diffOrder := dataBOX.diffOrder + 2;

  end; {SecondDiffOfVector}

  {________________________________________________}

  procedure SecondDiffandCentralise (var dataBOX: rBOX;
                  var dataVector: longVector);

    var
      t: integer;

  begin
    dataBOX.yMean := 0.0;
    dataBOX.yMax := dataVector[dataBOX.NOPUNCT - 1] - dataVector[dataBOX.NOPUNCT - 1];
    dataBOX.yMin := dataBOX.yMax;
    for t := dataBOX.NOPUNCT - 1 downto 1 do
      begin
        dataVector[t] := dataVector[t] - dataVector[t - 1];
        dataBOX.yMax := Rmax(dataBOX.yMax, dataVector[t]);
        dataBOX.yMin := Rmin(dataBOX.yMin, dataVector[t]);
        dataBOX.yMean := dataBOX.yMean + dataVector[t];
      end;
    dataVector[dataBOX.NOPUNCT] := 0.0;
    dataVector[0] := 0.0;

    dataBOX.NOPUNCT := dataBOX.NOPUNCT + 1;
    dataBOX.yMean := dataBOX.yMean / dataBOX.NOPUNCT;
    dataBOX.xMin := 0.0;
    dataBOX.xMax := dataBOX.NOPUNCT - 1;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;
    dataBOX.diffOrder := dataBOX.diffOrder + 1;
    dataBOX.DiffMode := central;

  end; {SecondDiffandCentalise}

 {________________________________________________}

  procedure CentralisedDiffernces (var dataBOX: rBOX;
                  var dataVector: longVector);
    var
      store, storelag: real;
      t: integer;

  begin

    dataBOX.yMax := dataVector[2] - 2 * dataVector[1] + dataVector[0];
    dataBOX.yMin := dataBOX.yMax;
    storelag := dataVector[0];
    for t := 1 to dataBOX.NOPUNCT - 2 do
      begin
        store := dataVector[t];
        dataVector[t] := dataVector[t + 1] - 2 * dataVector[t] + storelag;
        storelag := store;
        dataBOX.yMax := Rmax(dataBOX.yMax, dataVector[t]);
        dataBOX.yMin := Rmin(dataBOX.yMax, dataVector[t]);
        dataBOX.yMean := dataBOX.yMean + dataVector[t];
      end; {t}

    dataVector[0] := dataVector[1];
    dataVector[dataBOX.NOPUNCT - 1] := dataVector[dataBOX.NOPUNCT - 2];

    dataBOX.yMean := dataBOX.yMean / (dataBOX.NOPUNCT - 2);
    dataBOX.xMin := 0.0;
    dataBOX.xMax := dataBOX.NOPUNCT - 1;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;
    dataBOX.diffOrder := dataBOX.diffOrder + 2;
    dataBOX.DiffMode := central;

 {This the latest version. Perhap we should remake the dataBox herein}
  end; {CentralisedDifferences}

 {________________________________________________}

  procedure SecondDiffsCentralised (var dataBOX: rBOX;
                  var dataVector: longVector);
    var
      t: integer;

  begin
    for t := dataBOX.NOPUNCT downto 1 do
      dataVector[t] := dataVector[t - 1];

    dataVector[dataBOX.NOPUNCT + 1] := 0.0;
    dataVector[0] := 0.0;
    dataBOX.NOPUNCT := dataBOX.NOPUNCT + 2;
    dataBOX.DiffMode := central;

  end; {SecondDiffsCentralised}

 {________________________________________________}

  procedure DoubleDifference (var dataBOX: rBOX;
                  var dataVector: longVector);

  {This is the central second diffences x(t) = y(t-1) - 2y(t) + y(t+1) }

    var
      t: integer;
      yt, ytm1: real;

  begin
    dataBOX.yMean := 0.0;
    dataBOX.yMax := 0.0;
    dataBOX.yMin := 0.0;
    ytm1 := 0.0;

    for t := 1 to dataBOX.NOPUNCT - 2 do
      begin
        yt := dataVector[t - 1] - 2 * dataVector[t] + dataVector[t + 1];
        dataVector[t - 1] := ytm1;
        ytm1 := yt;
        dataBOX.yMax := Rmax(dataBOX.yMax, yt);
        dataBOX.yMin := Rmin(dataBOX.yMin, yt);
        dataBOX.yMean := dataBOX.yMean + yt;
      end;
    dataVector[dataBOX.NOPUNCT - 2] := ytm1;
    dataVector[dataBOX.NOPUNCT - 1] := 0.0;

    dataBOX.yMean := dataBOX.yMean / dataBOX.NOPUNCT;
    dataBOX.xMin := 0.0;
    dataBOX.xMax := dataBOX.NOPUNCT - 1;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;
    dataBOX.diffOrder := dataBOX.diffOrder + 2;

  end; {DoubleDifference}

  {________________________________________________}

  procedure SeasonalDifference (seasonLength: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);
    var
      d, t: integer;
      yMax, yMin, yMean: real;

  begin
    d := seasonLength;
    yMean := 0.0;
    yMax := dataVector[d] - dataVector[0];
    yMin := yMax;
    for t := 0 to dataBOX.NOPUNCT - d - 1 do
      begin
        dataVector[t] := dataVector[t + d] - dataVector[t];
  {dataVector[t] := dataVector[t + d];}
        yMax := Rmax(ymax, dataVector[t]);
        yMin := Rmin(ymin, dataVector[t]);
        yMean := yMean + dataVector[t];
      end;
    dataBOX.NOPUNCT := dataBOX.NOPUNCT - d;
    yMean := yMean / dataBOX.NOPUNCT;
    dataBOX.yMean := yMean;
    dataBOX.yMax := yMax; {the maximum value of y in the Data vector}
    dataBOX.yMin := yMin; {the minimum value of y in the Data vector}
    dataBOX.xMin := 0.0;
    dataBOX.xMax := dataBOX.NOPUNCT - 1;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;

  {Writeln('     The  original data has been replaced by its ', d : 1, '-period differences.');}
  {Writeln(' ' : 64, '<RETURN>');}
  {Readln;}

  end;{SeasonalDifference}

  {________________________________________________}

    procedure Decimate (step: integer;
                    var dataBOX: rBOX;
                    var dataVector: longVector);

  {This is called by procedure <<SubsampleTheData>>}

      var
        t, tau: integer;
    begin
      tau := 0;
      with dataBOX do
        begin {with dataBOX}
          yMean := 0.0;
          yMax := dataVector[0];
          yMin := dataVector[0];
          xMax := 0.0;
          xMin := 0.0;
          for t := 0 to NOPUNCT - 1 do
            begin {t}
              if (t mod step) = 0 then
                begin {if}
                  dataVector[tau] := dataVector[t];
                  tau := tau + 1;
                  yMax := Rmax(yMax, dataVector[t]);
                  yMin := Rmin(yMin, dataVector[t]);
                  yMean := yMean + dataVector[t];
                end; {if}
            end; {t}
          NOPUNCT := tau;
          yMean := yMean / NOPUNCT;
          xMin := 0.0;
          xMax := NOPUNCT - 1;
          yUB := yMax;
          yLB := 0.0;
          xLB := xMin;
          xRB := xMax;
        end; {with dataBOX}

    end; {Decimate}

  {________________________________________________}

    procedure SubsampleTheData (var dataBOX: rBOX;
                    var dataVector: longVector);

      var
        SampleStep: integer;

    begin
      if (not thereIsData) then
        ReadTheData(dataBOX, dataVector);

      if noPageParameters then
        PageSetUp(SCREENBOX, POSTBOX, PSPict, TeXFormat);

      ClrScr;
      Writeln;
      Writeln('    SUBSAMPLE THE DATA');
      Writeln;
      Writeln('    To subsample the date, select every nth point, where n in [2, 8].');
      Writeln('    Select  2, 3 or 4 etc. or type 1 to avoid subsampling');
      GetBoundedInteger(1, 8, SampleStep);
      if SampleStep in [2, 3, 4, 5, 6, 7, 8] then
        Decimate(SampleStep, dataBOX, dataVector);

      SubsampledData := true;

    end; {SubsampleTheData}

  {_________________________________________________}

  procedure DiscardData (var SCREENBOX: IBOX;
                  var dataBOX: rBOX;
                  var dateVector: longVector);
    var
      legend: string;
      theMenuChar: char;
      t, discard: integer;

  begin

    if thereIsData = false then
      begin
        ClrScr;
        Writeln;
        Writeln;
        Writeln('    DISCARD SOME THE DATA');
        Writeln;
        Sysbeep(3);
        Writeln('        There is no Data!');
        Writeln;
        Writeln(' ' : 60, '<RETURN>');
      end
    else
      begin  {there is date}

        if noPageParameters then
          begin
            SysBeep(3);
            PageSetUp(SCREENBOX, POSTBOX, PSPict, TeXFormat);
          end;

        ClrScr;
        Writeln;
        Writeln(' ' : 60, '<RETURN>');

        legend := DataLegend(dataBOX, dataName);
        ScreenMakePlot(dataBOX, SCREENBOX, dataVector, legend);

        Writeln;
        Writeln;
        Writeln('    DISCARD SOME THE DATA');
        Writeln;
        Writeln('       (a)    Discard Data from the Start');
        Writeln;
        Writeln('       (b)    Dicard Data from the End');
        Writeln;
        Writeln('        Select a or b and press RETURN');
        Readln(theMenuchar);
        theMenuChar := DownCase(theMenuchar);
        Writeln;
        Writeln(' How Many points do you wish to discard?');
        GetBoundedInteger(0, dataBOX.NOPUNCT, discard);

        if theMenuChar = 'a' then
          begin
            for t := 0 to dataBOX.NOPUNCT - discard - 1 do
              dateVector[t] := dataVector[t + discard];
          end;

        dataBOX.NOPUNCT := dataBOX.NOPUNCT - discard;
        MakeDataBox(dataBOX, dataVector);

        ClrScr;
        Writeln;
        Writeln(' ' : 60, '<RETURN>');

        legend := DataLegend(dataBOX, dataName);
        ScreenMakePlot(dataBOX, SCREENBOX, dataVector, legend);

      end; {there is data}

  end; {DiscardData}

{_________________________________________________}

  procedure ShortenTheData (var discard: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);


  {This procedure discards elements from the beginning of the dataVector and}
  {it shifts the remaining elements to the left by that number of cells}

    var
      t: integer;

  begin
    dataBOX.yMax := dataVector[discard];
    dataBOX.yMin := dataBOX.yMax;
    dataBOX.yMean := 0.0;
    dataBOX.NOPUNCT := dataBOX.NOPUNCT - discard;
    for t := 0 to dataBOX.NOPUNCT - 1 do
      begin
        dataVector[t] := dataVector[t + discard];
        dataBOX.yMax := Rmax(dataBOX.yMax, dataVector[t]);
        dataBOX.yMin := Rmin(dataBOX.yMin, dataVector[t]);
        dataBOX.yMean := dataBOX.yMean + dataVector[t];
      end;
    dataBOX.yMean := dataBOX.yMean / dataBOX.NOPUNCT;
    dataBOX.xMin := 0.0;
    dataBOX.xMax := dataBOX.NOPUNCT - 1;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;
    dataBOX.yUB := dataBOX.yMax;
    dataBOX.yLB := dataBOX.yMin;

  end; {ShortenTheData}

{________________________________________________}

  procedure SegmentTheData (var SCREENBOX, POSTBOX: IBOX;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

    var
      proceed, desegment, shareThem: boolean;
      segOption: char;
      segRemainder, extraPoints: integer;
      legend: string;

  begin
    proceed := true;

    if (thereIsData = false) then
      begin
        SysBeep(3);
        ReadTheData(dataBOX, dataVector);
      end;

    ClrScr;
    Writeln;
    Writeln('    SEGMENT THE DATA');
    Writeln;
    if dataBOX.segmentedData then
      begin {segmented}
        segRemainder := (dataBOX.NOPUNCT mod dataBOX.segLength);
        Writeln('    The data are already divided into ', dataBOX.numbOfSegs : 3, ' sements');
        Writeln('    of ', dataBOX.segLength : 3, ' points each with a remainder of ', segRemainder : 3, ' points');
        Writeln('    You may retain or revise the segmentation, or else you may dicard it.');
        Writeln;
        YesOrNo('    Do you wish to segment the data anew', proceed);
        if (proceed = false) then
          begin {proceed = false}
            YesOrNo('    Do you wish to remove the segmentation', desegment);
            if desegment then
              begin
                dataBOX.segmentedData := false;
                dataBOX.numbOfSegs := 1;
                dataBOX.segLength := dataBOX.NOPUNCT;
              end;
          end; {proceed = false}
      end  {segmented}
    else if (dataBOX.NOPUNCT < 100) then
      Writeln(' the number of data points is less that 100,  therefore segmentation is disallowed ');

    if (dataBOX.NOPUNCT >= 100) and proceed then
      begin {Define the segments}
        Writeln;
        Writeln('    There are currently ', dataBOX.NOPUNCT : 3, ' data points');
        Writeln('    Choose one of the following options and press <RETURN> ');
        repeat
          Writeln;
          Writeln('        (a) Specify the length of each segment ');
          Writeln;
          Writeln('        (b) Specify the number of segments ');
          Readln(segOption);
        until segOPtion in ['a', 'A', 'b', 'B'];

        case segOption of
          'a':
            begin {Option a}
              Writeln;
              repeat
                Writeln('    Specify the length of each segment');
                Readln(dataBOX.segLength);
                Writeln;
                if (dataBOX.segLength <= 50) then
                  Writeln('    The segement must have at least 50 points. Respecify the length');
              until (dataBOX.segLength >= 50);

              if dataBOX.segLength > dataBOX.NOPUNCT then
                Writeln('    The segment length exeeds the number of data points. Respecify the segment length');
              if dataBOX.segLength < dataBOX.NOPUNCT then
                dataBOX.numbOfSegs := dataBOX.NOPUNCT div dataBOX.segLength;
              segRemainder := dataBOX.NOPUNCT mod dataBOX.segLength;
              Writeln('    The number of segments is ', dataBOX.numbOfSegs : 3);
              Writeln('    The  remaining number of points is ', segRemainder : 3);
              if (dataBOX.numbOfSegs > 1) and (segRemainder > dataBOX.numbOfSegs) then
                YesorNo('    Do you wish to share the remaining points amongst the segments', shareThem);

              if shareThem then
                begin {add extraPoints }
                  extraPoints := segRemainder div dataBOX.numbOfSegs;
                  dataBOX.segLength := dataBOX.segLength + extraPoints;
                  Writeln('    The segment length is ', dataBOX.segLength : 3);
                  Writeln('    The number of segments is ', dataBOX.numbOfSegs : 3);
                  segRemainder := dataBOX.NOPUNCT mod dataBOX.segLength;
                  Writeln('    The remaining number of points is ', segRemainder : 3);
                  Writeln(' ' : 60, '<RETURN>');
                  Readln;
                end; {add extraPoints }

            end; {OPTION a}
          'b':
            begin {OPTION b}
              repeat
                Writeln;
                Writeln('    Specify the number of segments');
                Readln(dataBOX.numbOfSegs);
                dataBOX.segLength := dataBOX.NOPUNCT div dataBOX.numbOfSegs;
                Writeln;
                if (dataBOX.segLength <= 50) then
                  begin
                    Writeln('    The segment must have at least 50 points. Respecify the number');
                    Writeln('    The number of segments cannot exceed ', dataBOX.NOPUNCT div 50 : 3);
                  end;
              until (dataBOX.segLength >= 50);
              segRemainder := dataBOX.NOPUNCT mod dataBOX.segLength;
              Writeln('    The segment length is ', dataBOX.segLength : 3);
              segRemainder := dataBOX.NOPUNCT mod dataBOX.segLength;
              Writeln('    The remaining number of points is ', segRemainder : 3);
              Writeln(' ' : 60, '<RETURN>');
              Readln;
            end; {OPTION b}

        end; {Cases}

        dataBOX.segmentedData := true
      end; {define the segments}

    if noPageParameters then
      begin
        SysBeep(3);
        PageSetUp(SCREENBOX, POSTBOX, PSPict, TeXFormat);
      end;

    SegmentedPlot(SCREENBOX, POSTBOX, dataBOX, dataVector, legend);

  end; {SegmentTheData}

{_________________________________________________}

  procedure DiscardQuestion (var discard: Boolean);

  begin
    ClrScr;
    Writeln;
    Writeln;
    Writeln('    DISCARD THE EXTRAPOLATIONS');
    Writeln;
    Writeln('    The data have been supplemented by ', dataBOX.EXTRA : 2, ' points at each end.');
    YesOrNo('    Do you wish  to discard the extrapolated data points', discard);
    Writeln;
    Writeln(' ' : 60, '<RETURN>');
    Readln;

  end; {DiscardQuestion}

  {________________________________________________}

  procedure DiscardExtraData (var dataBOX: rBOX;
                  var dataVector: longVector);
    var
      t, Tcap, Tadd: integer;

  begin
    Tcap := dataBOX.NOPUNCT;
    Tadd := dataBOX.EXTRA;
    Tcap := Tcap - 2 * Tadd;
    dataBOX.yMax := dataVector[Tadd];
    dataBOX.yMin := dataVector[Tadd];
    dataBOX.yMean := 0.0;

     {Shift data to the Left}
    for t := 0 to Tcap - 1 do
      begin {t}
        dataVector[t] := dataVector[t + Tadd];
        dataBOX.yMax := Rmax(dataBOX.yMax, dataVector[t]);
        dataBOX.yMin := Rmin(dataBOX.yMin, dataVector[t]);
        dataBOX.yMean := dataBOX.yMean + dataVector[t];
      end; {t}

    dataBOX.NOPUNCT := Tcap;
    dataBOX.yMean := dataBOX.yMean / dataBOX.NOPUNCT;
    dataBOX.xMax := Tcap - 1;
    dataBOX.xMin := 0.0;
    dataBOX.xLB := dataBOX.xMin;
    dataBOX.xRB := dataBOX.xMax;
    dataBOX.EXTRA := 0;

  end; {DiscardExtraData}

  {________________________________________________}

  procedure TransferTheData (var diffOrder: integer;
                  var dataBOX, trendBOX: rBOX;
                  var dataVector, trendVector: longVector);

    var
      d: integer;

  begin
    trendVector := dataVector;
    trendBOX := dataBOX;

    d := 0;
    if (diffOrder > 0) then
      repeat
        DiffOfVector(trendBOX, trendVector);
  {DiffOfVector will modify trendBOX.NOPUNCT}
        d := d + 1
      until (d = diffOrder);

  end; {TransferTheData}

  {________________________________________________}

  procedure ExplainWeightedRegression;

  begin
    ClrScr;
    Writeln;
    Writeln;
    Writeln('    WEIGHTED LEAST-SQUARES POLYNOMIAL REGRESSION');
    Writeln;
    Writeln('    The  objective is to ensure that  the fitted  polynomial will  pass');
    Writeln('    through the  midst of the scatters of  points  at either end of the');
    Writeln('    sample. This is to ensure that there are no radical disjunctions in');
    Writeln('    the  periodic extension of  the residual sequence where  the end of');
    Writeln('    one  replication of the  sequence  joins the beginning of the  next');
    Writeln('    replication. To  achieve this, the  polynomial is fitted by a least');
    Writeln('    squares regression, in which the maximum weight is given  to either');
    Writeln('    end of the sample and the minimum weight is at its mid point.');
    Writeln;
    Writeln(' ' : 63, '<RETURN>');
    Readln;
    ClrScr;

    Writeln;
    Writeln('    WEIGHTED LEAST-SQUARES POLYNOMIAL REGRESSION');
    Writeln;
    Writeln('    The user  is first asked  to specify the  maximum  and  the minimum');
    Writeln('    weights---the latter  being unity  by  default. They are also asked');
    Writeln('    to specify a U-shaped profile according  to  which the weights make');
    Writeln('    their transition from  the minimum to the maximum  values. Two such');
    Writeln('    choices are a  quadratic function  and a  crenelated  function that');
    Writeln('    jumps abruptly from the minimum value, which is maintained  over an');
    Writeln('    interval centred on the mid point, to  the maximum value, which, by');
    Writeln('    default, is the  value in  the first  and  the last quarters of the');
    Writeln('    sample.');
    Writeln;
    Writeln('    There is  also an  option  for  splitting  the quadratic  by inter-');
    Writeln('    polating  a  constant segment into  an interval centred on the  mid');
    Writeln('    point. The  equivalent option in respect of the crenelated function');
    Writeln('    is to allow  variations  in  the range in over which  the weighting');
    Writeln('    function assumes its minimum value');
    Writeln;
    Writeln(' ' : 63, '<RETURN>');
    Readln;

  end; {ExplainWeightedRegression}

  {_______________________________________________}

  procedure FitPolyTrend (var polyParas: polyParameters;
                  var dataBOX, trendBOX, residueBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var dataVector, trendVector, residueVec: longVector);

  {Called by MAIN}
  {This serves to plot the polynomial trend and the residual vector}
  {We need to put cycleVec and cycleBOX in the parameter list}
    var
      PolyWgts: longVector;
      legend: string;
      replace: boolean;
      MenuChoice: integer;

  begin
    if noPageParameters then
      begin
        SysBeep(3);
        PageSetup(SCREENBOX, POSTBOX, PSPict, TeXFormat); {in UTILS}
      end;

    if (thereIsData = false) then
      begin
        SysBeep(3);
        ReadTheData(dataBOX, dataVector); {in UTILS}
      end;

    ClrScr;
    Writeln;
    Writeln('     FIT A POLYNOMIAL TREND');
    Writeln;
    Writeln('    1.   Fit by Ordinary Least-Squares Regression');
    Writeln;
    Writeln('    2.   Fit by Weighted Least-Squares Regression');
    Writeln;
    Writeln('                      Select a number and press <RETURN>');

    GetBoundedInteger(1, 2, menuChoice);
    case menuChoice of
      1: 
        UniformWgts(PolyWgts, dataBOX);
      2: 
        begin
          ExplainWeightedRegression;
          GettheWeights(PolyWgts, dataBOX, SCREENBOX); {in POLYNOME}
        end;
    end; {case}

    Writeln;
    Writeln('    What is the degree of the polynomial?');
    GetBoundedInteger(0, 12, polyParas.polyDegree);
  {_________This is the end of the interface section which should go into  Organise_____}

    trendBOX := dataBOX;
    trendBOX.xMin := 0;
    residueBOX := trendBOX;
    MakePolyTrend(polyParas, dataBOX, trendBox, residueBOX, dataVector, trendVector, residueVec, PolyWgts);

    if menuChoice = 1 then
      legend := PolynomialTrend(polyParas.polyDegree, dataBOX, dataName);
    if menuChoice = 2 then
      legend := PolyWeightTrend(polyParas.polyDegree, dataBOX, dataName);

    ScreenOverplot(dataBOX, SCREENBOX, dataVector, trendVector, legend);

    if PSPict then
      WritePostOverFile(dataBOX, POSTBOX, dataVector, trendVector, legend);

    legend := PolynomialResiduals(polyParas.polyDegree, dataBOX, dataName);
    ScreenMakePlot(residueBOX, SCREENBOX, residueVec, legend);

    if PSPict then
      WritePostFile(residueBOX, POSTBOX, residueVec, legend);

    if (suppressReplace = false) then
      begin {suppressReplace}
        ClrScr;
        Writeln;
        Writeln('     FIT A POLYNOMIAL TREND');
        Writeln;
        YesOrNo('    Do you wish to replace the data series by the residual series', replace);
        if replace then
          begin {replace}
            cycleVec := dataVector;
            cycleBOX := dataBOX;
            dataBOX := residueBOX;
            dataVector := residueVec;
            MakeDataBox(dataBOX, dataVector);
            residualsInData := true;
          end; {replace}
      end; {suppressReplace}

{NB. when dataVector <== residueVec, then CycleVec <== dataVector}

    weHaveATrend := true;
    weHaveTrendResiduals := true;

  end; {FitPolyTrend}

{_________________________________________________}

  procedure MakeFrequencyBand (var dataBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var stripRect: integerRect;
                  var postRect: realRect);

    var
      BOXWidth: integer;
      postWidth: real;
      longPeriod, shortPeriod: integer;
      lowerLimit, upperLimit: real;
      FiniteTime: boolean;

  begin {ImposeBand}

    Writeln('    Specify the lower limit of the frequency band in degrees');
    ReadBoundedNumber(0.0, 180.0, lowerLimit);
    Writeln('    Specify the upper limit of the frequency band in degrees');
    ReadBoundedNumber(lowerLimit, 180.0, upperLimit);

    BOXWidth := SCREENBOX.X2 - SCREENBOX.X1;
    with stripRect do
      begin {stripRect}
        VTS := SCREENBOX.Y1;
        HRS := SCREENBOX.X1 + Round(BOXWidth * lowerLimit / 180);
        VTF := SCREENBOX.Y2;
        HRF := SCREENBOX.X1 + Round(BOXWidth * upperLimit / 180);
      end; {stripRect}

    postWidth := POSTBOX.X2 - POSTBOX.X1;
    with postRect do
      begin {postRect}
        top := POSTBOX.Y1;
        left := SCREENBOX.X1 + (postWidth * lowerLimit / 180);
        bottom := POSTBOX.Y2;
        Right := POSTBOX.X1 + (postWidth * upperLimit / 180);
      end; {postRect}

    longPeriod := Round(360 / lowerLimit);
    if Round(lowerLimit) <> 0 then
      begin
        FiniteTime := true;
        shortPeriod := Round(360 / upperLimit);
      end;

    if dataBOX.dataFrequency = Monthly then
      begin {Monthly}
        if FiniteTime then
          begin
            Writeln('    The frequency band contains cycles ranging in duration from ');
            Writeln('    ', shortPeriod : 2, ' months to ', longPeriod : 2, ' months')
          end
        else
          begin
            Writeln('    The frequency band contains cycles ranging in duration up to ');
            Writeln('    ', longPeriod : 2, ' months')
          end;
      end; {Monthly}

    if dataBOX.dataFrequency = Quarterly then
      begin {quarterly}
        if FiniteTime then
          begin
            Writeln('    The frequency band contains cycles ranging in duration from ');
            Writeln('    ', shortPeriod : 2, ' quarters to ', longPeriod : 2, ' quarters')
          end
        else
          begin
            Writeln('    The frequency band contains cycles of duration up to ');
            Writeln('    ', longPeriod : 2, ' months')
          end;
      end; {quarterly}

    if dataBOX.dataFrequency = Annual then
      begin {annual}
        if FiniteTime then
          begin
            Writeln('    The  frequency band contains cycles ranging in duration from ');
            Writeln('    ', shortPeriod : 2, ' years to ', longPeriod : 2, ' years');
          end
        else
          begin
            Writeln('    The  frequency band contains cycles of duration up to ');
            Writeln('    ', longPeriod : 2, ' years')
          end;
      end; {annual}

  end; {MakeFrequencyBand}

{________________________________________________}

  procedure FillPostRect (var F: text;
                  var PostRect: realRect);

  begin

    with PostRect do
      begin
        Writeln(F, 'newpath');
        Writeln(F, Left : 3 : 2, ' ', Top : 3 : 2, ' moveto');
        Writeln(F, Right : 3 : 2, ' ', Top : 3 : 2, ' lineto');
        Writeln(F, Right : 3 : 2, ' ', Bottom : 3 : 2, ' lineto');
        Writeln(F, Left : 3 : 2, ' ', Bottom : 3 : 2, ' lineto');
        Writeln(F, 'closepath');
        Writeln(F, '0.8 setgray');
        Writeln(F, 'fill');
        Writeln(F, '0.0 setgray');
      end;

  end; { FillPostRect}

  {________________________________________________}

  procedure PlotThePeriodogam (var dataBOX: rBOX;
                  var SCREENBOX, POSTBOX: IBOX;
                  var dataVector: longVector;
                  var legend: string);

    var
      spectraBOX: rBOX;
      enoughData, fileThem: boolean;
      i, Ncap, Tcap: integer;
      maxi, pi: real;
      x, xi: longVector;
      spectraVector: pointsVector;
      postFileName, periFileName: string;
      F: text;
      {MacStripRect: Rect;} {This is for the Mac}
      StripRect: integerRect; {This is for Windows}
      PostRect: realRect; {This is for PostScript}

  begin
    pi := 4.0 * Arctan(1.0);
    enoughData := true;

    if imposeBand then
      begin
        ClrScr;
        Writeln;
        Writeln('         PLOT THE PERIODOGRAM');
        Writeln;
        MakeFrequencyBand(dataBOX, SCREENBOX, POSTBOX, stripRect, postRect);
        {MakeFrequencyBand(dataBOX, SCREENBOX, POSTBOX, stripRect, MacStripRect, postRect);}
        Writeln;
        Writeln(' ' : 60, '<RETURN>');
        Readln;
      end;

    if noPageParameters then
      begin
        SysBeep(3);
        PageSetUp(SCREENBOX, POSTBOX, PSPict, TeXFormat);
      end;

    for i := 0 to dataBOX.NOPUNCT - 1 do
      x[i] := dataVector[i] - dataBOX.yMean;

  {We need to calculate the Mean of the series at this point}
  {or at the point at which it is generated}

    if (dataBOX.NOPUNCT < 16) then
      begin {dataBOX.NOPUNCT < 16}
        ClrScr;
        Writeln;
        SysBeep(3);
        Writeln('    PLOT THE PERIODOGRAM');
        Writeln;
        Writeln('    There are ', dataBOX.NOPUNCT : 1, ' data points ');
        Writeln('    More points are needed for calculating the periodogram');
        Writeln;
        Writeln(' ' : 60, '<RETURN>');
        Readln;
        enoughData := false;
      end; {NOPUNCT < 16}

    if enoughData then
      begin {enoughData}
        Ncap := dataBOX.NOPUNCT;
        RealMixedRadix(x, xi, Ncap);
        Tcap := Ncap div 2;
        Periodogram(xi, spectraVector, maxi, Ncap);

        Writeln(' ' : 60, '<RETURN>');
        GetGraphics(graphicsOn, SCREENBOX, currentMode);

        spectraBOX.xMax := pi;
        spectraBOX.xMin := 0;
        spectraBOX.yMax := maxi;
        spectraBOX.yMin := 0;
        spectraBOX.yUB := maxi;
        spectraBOX.yLB := 0;
        spectraBOX.xLB := 0;
        spectraBOX.xRB := pi;
        spectraBOX.NOPUNCT := Tcap + 1;

        SCREENBOX.xAxis := false;

        if imposeBand then
          begin
            SetFillStyle(closeDotFill, yellow);
            Bar(stripRect.HRS, stripRect.VTS, stripRect.HRF, stripRect.VTF);
            Rectangle(stripRect.HRS, stripRect.VTS, stripRect.HRF, stripRect.VTF);
          end;

        ScreenFrameLite(spectraBOX, SCREENBOX);

        ZeroPiAxis(SCREENBOX);
        ScreenBiPlot(spectraBOX, SCREENBOX, spectraVector);

        ScreenCaption(legend);

        CallForReturn;
        Readln;
        CloseGraph;
        RestoreCrtMode;
        ClrScr;

        Writeln;
        Writeln('    PERIODOGRAM ANALYSIS');
        Writeln;
        fileThem := false;
        YesorNo('    Do you wish to save the periodogram ordinates', fileThem);
        Writeln;
        if fileThem = true then
          begin {fileThem}
            Write('    Name the periodogram File = ');
            Readln(periFileName);
            if periFileName <> '' then
              begin {if}
                Assign(F, periFileName);
                Rewrite(F);
                Writeln(F);
                Writeln(F, ' Index      Radians     Ordinate');
                Writeln(F);
                for i := 0 to spectraBOX.NOPUNCT - 1 do
                  begin {i}
                    Writeln(F, '  ', i : 2, '     ', spectraVector[i].x : 10 : 5, '  ', spectraVector[i].y : 10 : 5)
                  end; {i}
                Close(F);
                Writeln;
              end; {if}
          end; {fileThem}

        if PSPict = true then
          begin
            Write('    Name the Postscript File = ');
            Readln(postFileName);
            if postFileName <> '' then
              begin {postFileName}
                Assign(F, postFileName);
                ReWrite(F);
                PostHeader(F, POSTBOX, TeXFormat);
                POSTBOX.xAxis := false;
                POSTBOX.yAxis := true;
                POSTBOX.doFrame := true;
                POSTBOX.doMarks := true;
                if imposeBand then
                  FillPostRect(F, PostRect);
                PostFrame(F, spectraBOX, POSTBOX);
                PostZeroPiAxis(F, POSTBOX);
                PostBiPlot(F, spectraBOX, POSTBOX, spectraVector);
                PostFooter(F, POSTBOX, legend, TeXFormat);
                Close(F);
              end; {postFileName}
          end; {PSPict }
      end; {enoughData}

  {Restore the x-axis}
    SCREENBOX.xAxis := true;
    POSTBOX.xAxis := true;

  end; {PlotThePeriodogam}

  {________________________________________________}

   procedure MultiPeriodogram (superimpose: boolean;
                   var SCREENBOX: IBOX;
                   var dataBOX: rBOX;
                   var dataVector: longVector);

     var
       postFiles: boolean;
       plotNumber, s, t: integer;
       maxy, maxz: real;
       segVector, periodoVec: longVector;
       periodoBOX: rBOX;
       legend, postFileName: string;
       F: text;

   begin
     legend := ' ';
     plotNumber := 0;
     s := 0;

     periodoBOX.NOPUNCT := dataBOX.segLength;

     maxz := 0; {this will record the maximum of maxy}
     repeat
       for t := 0 to dataBOX.segLength - 1 do
         segVector[t] := dataVector[s + t]; {plotVector --> segVector}

       SlowPeriodogram(dataBOX, periodoBOX, segVector, periodoVec);

       if (not superimpose) or (superimpose and (plotNumber = 0)) then
         begin
           GetGraphics(graphicsOn, SCREENBOX, currentMode);
           SCREENBOX.xAxis := false;
           ScreenFrame(periodoBOX, SCREENBOX);
           ZeroPiAxis(SCREENBOX);
           maxy := periodoBOX.yMax;
           maxz := Rmax(maxz, maxy);
         end;

       periodoBOX.yMax := maxy;
       ScreenPlot(periodoBOX, SCREENBOX, periodoVec);

       if not superimpose then
         begin {new frame}
           CallForReturn;
           Readln;
           CloseGraph;
           RestoreCrtMode;
           ClrScr;
         end; {new frame}

       plotNumber := plotNumber + 1;
       s := s + dataBOX.segLength;

     until plotNumber = dataBOX.numbOfSegs;

     if superimpose then
       begin {ClrScr}
         CallForReturn;
         Readln;
         CloseGraph;
         RestoreCrtMode;
         ClrScr;
       end; {ClrScr}

     SCREENBOX.xAxis := true;

     if PSPict then
       begin {PSPict}
         YesOrNo('    Do you wish to create the PostScript files', postFiles);

         if postFiles then
           begin {postFiles}
             if (not superimpose) then
               begin {not superimpose}
                 plotNumber := 0;
                 s := 0;
                 repeat
                   for t := 0 to dataBOX.segLength - 1 do
                     segVector[t] := dataVector[s + t];
                   SlowPeriodogram(dataBOX, periodoBOX, segVector, periodoVec);
                   WritePostSpectral(periodoBOX, POSTBOX, periodoVec, legend);
                   plotNumber := plotNumber + 1;
                   s := s + dataBOX.segLength;
                 until plotNumber = dataBOX.numbOfSegs;
               end; {not superimpose}

             if superimpose then
               begin {superimpose}
                 plotNumber := 0;
                 s := 0;
                 periodoBOX.yMax := maxz;
                 Write('    Name the Postscript File = ');
                 Readln(postFileName);
                 if postFileName <> '' then
                   begin {postFileName}
                     Assign(F, postFileName);
                     ReWrite(F);
                     PostHeader(F, POSTBOX, TeXFormat);
                     POSTBOX.xAxis := false;
                     POSTBOX.yAxis := true;
                     POSTBOX.doFrame := true;
                     POSTBOX.doMarks := true;
                     PostFrame(F, periodoBOX, POSTBOX);
                     PostZeroPiAxis(F, POSTBOX);

                     repeat {until}
                       for t := 0 to dataBOX.segLength - 1 do
                         segVector[t] := dataVector[s + t];
                       SlowPeriodogram(dataBOX, periodoBOX, segVector, periodoVec);
                       PostPlot2(F, periodoBOX, POSTBOX, periodoVec);
 {PostPlot(F, periodoBOX, POSTBOX, periodoVec);}
                       plotNumber := plotNumber + 1;
                       s := s + dataBOX.segLength;
                     until plotNumber = dataBOX.numbOfSegs;
                     PostFooter(F, POSTBOX, legend, TeXFormat);
                     Close(F);
                   end; {F}
               end; {superimpose}

             POSTBOX.xAxis := true;
           end; {postFiles}

       end; {PSPict = true}
   end; {MultiPeriodogram}

 {_________________________________________________}

  procedure ExitRoutine (var dataBOX, trendBOX, residueBOX, seasonBOX: rBOX;
                  var dataVector, trendVector, residueVec, seasonVec: longVector);
{It seems that this is not used: <SaveAndExit takes> its place}
    var
      menuChar: char;

  begin
    ClrScr;
    Writeln;
    Writeln;
    Writeln('         SAVE AND EXIT');
    Writeln;
    Writeln;
    allsDone := false;

    menuChar := 'x';
    repeat
      if thereIsData then
        begin
          Writeln('        (d) Save the Data');
          Writeln;
        end;
      if weHaveATrend then
        begin
          Writeln('        (t) Save the Trend Component');
          Writeln;
        end;
      if weHaveTrendResiduals then
        begin
          Writeln('        (z) Save the Trend Residuals');
          Writeln;
        end;
      if weHaveSeasonalComponent then
        begin
          Writeln('        (s) Save the Seasonal Component');
          Writeln;
        end;
      Writeln('        (r) Return to the Main Menu');
      Writeln;
      Writeln('        (e) Exit');
      Writeln;
      ReadAChar(menuChar);
      menuChar := DownCase(menuChar);
    until menuChar in ['d', 't', 'z', 's', 'r', 'e'];

    case MenuChar of
      'd', 'D': 
        if (thereIsData) then
          WriteData(dataBOX, dataVector);
      't': 
        if (weHaveATrend) then
          WriteData(trendBOX, trendVector);
      'z': 
        if (weHaveTrendResiduals) then
          WriteData(residueBOX, residueVec);
      's': 
        if (weHaveSeasonalComponent) then
          WriteData(seasonBOX, seasonVec);
      'e': 
        allsDone := true;
    end;{case}

  end; {ExitRoutine}

  {________________________________________________}

  procedure GenerateTestData (var dataBOX: rBOX;
                  var dataVector: longVector);

    var
      Tcap, t, s: integer;
  begin
    Tcap := 20;
    dataBOX.NOPUNCT := Tcap;

    dataVector[0] := 1;
    dataVector[1] := 4;
    dataVector[2] := 7;
    dataVector[3] := 2;
    dataVector[4] := 0;
    dataVector[5] := 6;
    for t := 6 to Tcap - 1 do
      begin {t}
        s := t mod 6;
        dataVector[t] := dataVector[s];
      end; {t}

    Tcap := 50;
    dataBOX.NOPUNCT := Tcap;
    dataVector[0] := 1;
    for t := 1 to 50 do
      dataVector[t] := 0.0;

    thereIsData := true;
  end;{GenerateTestData}

  {________________________________________________}

  procedure EndYearInterpolation (var alpha, beta: real;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

  {This procedure interpolates a straight line through the data points of the}
  {first year and the final year according to the least-squares criterion.}

    var
      t, q, twoQ, Tcap: integer;
      sumX, sumY, sumXY, sumXX, numerator, denominator: real;

  begin
    Tcap := dataBOX.NOPUNCT;
    if (dataBOX.dataFrequency = Quarterly) then
      q := 4;
    if (dataBOX.dataFrequency = Monthly) then
      q := 12;
    twoQ := 2 * q;

    sumX := 0.0;
    sumY := 0.0;
    sumXY := 0.0;
    sumXX := 0.0;
    for t := 0 to q - 1 do
      begin
        sumX := sumX + t;
        sumXX := sumXX + t * t;
        sumY := sumY + dataVector[t];
        sumXY := sumXY + t * dataVector[t];
      end;
    for t := Tcap - q to Tcap - 1 do
      begin
        sumX := SumX + t;
        sumXX := sumXX + t * t;
        sumY := sumY + dataVector[t];
        sumXY := sumXY + t * dataVector[t];
      end;

    numerator := sumXY - (sumX * sumY / twoQ);
    denominator := sumXX - (sumX * sumX / twoQ);
    beta := numerator / denominator;
    alpha := (sumY - beta * sumX) / twoQ;

  end; {EndYearInterpolation}

{________________________________________________}

  procedure RotateData (RoteNo: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

{This procedure subtracts a segment from the top}
{of the data and places is at the bottom end.}

    var
      storeVector: vector; {limited to 100 elements}
      t, Tcap, rotaCount, rotaTask: integer;

  begin
    Tcap := dataBOX.NOPUNCT;
    rotaCount := RoteNo;

    repeat
      if (rotaCount > 50) then
        rotaTask := 50
      else
        rotaTask := rotaCount;

{copy}
      for t := 0 to rotaTask - 1 do
        storeVector[t] := dataVector[Tcap - rotaTask + t];

{displace}
      for t := 1 to Tcap - rotaTask do
        dataVector[Tcap - t] := dataVector[Tcap - t - rotaTask];

{deposit}
      for t := 0 to rotaTask - 1 do
        dataVector[t] := storeVector[t];

      rotaCount := rotaCount - rotaTask;
    until (rotaCount = 0);

  end; {RotateData}

{________________________________________________}

  procedure AntiRotateData (RoteNo: integer;
                  var dataBOX: rBOX;
                  var dataVector: longVector);

{This procedure subtracts a segment from the }
{bottom of the data and places is at the top end.}

    var
      storeVector: vector; {limited to 100 elements}
      t, Tcap, rotaCount, rotaTask: integer;

  begin
    Tcap := dataBOX.NOPUNCT;
    rotaCount := RoteNo;

    repeat
      if (rotaCount > 50) then
        rotaTask := 50
      else
        rotaTask := rotaCount;

{copy}
      for t := 0 to rotaTask - 1 do
        storeVector[t] := dataVector[t];

{displace}
      for t := 0 to Tcap - 1 - rotaTask do
        dataVector[t] := dataVector[t + rotaTask];

{deposit at the top}
      for t := 0 to RoteNo - 1 do
        dataVector[Tcap - rotaTask + t] := storeVector[t];

      rotaCount := rotaCount - rotaTask;
    until (rotaCount = 0);

  end; {AntiRotateData}

{________________________________________________}

end. {DATASEG: Unit 11 of NEWIDEOLOG.PAS}

